Bug 1064140 (CVE-2014-0057) - CVE-2014-0057 CFME: Dangerous send in ServiceController
Summary: CVE-2014-0057 CFME: Dangerous send in ServiceController
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2014-0057
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
high
high
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On: 1064143 1064144
Blocks: 1064142
TreeView+ depends on / blocked
 
Reported: 2014-02-12 05:40 UTC by Kurt Seifried
Modified: 2023-05-12 17:51 UTC (History)
11 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-03-17 19:58:50 UTC
Embargoed:


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2014:0215 0 normal SHIPPED_LIVE Critical: cfme security, bug fix, and enhancement update 2014-03-11 20:56:48 UTC

Description Kurt Seifried 2014-02-12 05:40:49 UTC
Jan Rusnacko of the Red Hat Product Security Team reports:

CFME contains an unsafe invocation of send method on user-supplied
argument. This issue is reported by Brakeman as problem in ServiceController
method x_button:

vmdb/app/controllers/service_controller.rb

16 def x_button
17 @explorer = true
18 model, action = pressed2model_action(params[:pressed])
19 @sb[:action] = action
20 if ["ownership","tag"].include?(action)
21 self.send(params[:pressed],"Service")
22 else
23 self.send(params[:pressed])
24 end

Assuming pressed2model_action sanitizes user input, this look like
false-positive. However, pressed2model_action does not do sanitization, and only
splits string on underscore:

def pressed2model_action(pressed)
pressed =~ /^(vm_vdi|miq_template)_(.*)$/ ? [$1, $2] : pressed.split('_', 2)
end

If action parsed from user-supplied input is neither "ownership", nor "tag",
else branch is executed and client can execute arbitrary method on controller,
including private.

Comment 3 Martin Prpič 2014-02-24 18:58:03 UTC
Acknowledgements:

This issue was discovered by Jan Rusnacko of the Red Hat Product Security Team.

Comment 4 errata-xmlrpc 2014-03-11 16:59:13 UTC
This issue has been addressed in following products:

  CloudForms Management Engine 5.x

Via RHSA-2014:0215 https://rhn.redhat.com/errata/RHSA-2014-0215.html


Note You need to log in before you can comment on or make changes to this bug.